Index: LMDZ5/branches/testing/libf/dynphy_lonlat/calfis.F
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/calfis.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/calfis.F	(revision 2641)
@@ -34,5 +34,7 @@
       USE callphysiq_mod, ONLY: call_physiq
 #endif 
-
+      USE comconst_mod, ONLY: cpp, daysec, dtphys, dtvr, kappa, pi
+      USE comvert_mod, ONLY: preff, presnivs
+      
       IMPLICIT NONE
 c=======================================================================
@@ -89,15 +91,12 @@
 c    ------------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "temps.h"
+      include "dimensions.h"
+      include "paramet.h"
 
       INTEGER ngridmx
       PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
 
-#include "comconst.h"
-#include "comvert.h"
-#include "comgeom2.h"
-#include "iniprint.h"
+      include "comgeom2.h"
+      include "iniprint.h"
 
 c    Arguments :
@@ -142,6 +141,8 @@
 c
       REAL zrot(iip1,jjm,llm) ! AdlC May 2014
-      REAL zufi(ngridmx,llm), zvfi(ngridmx,llm), zrfi(ngridmx,llm)
+      REAL zufi(ngridmx,llm), zvfi(ngridmx,llm)
+      REAL zrfi(ngridmx,llm) ! relative wind vorticity
       REAL ztfi(ngridmx,llm),zqfi(ngridmx,llm,nqtot)
+      REAL zpk(ngridmx,llm)
 c
       REAL pcvgu(ngridmx,llm), pcvgv(ngridmx,llm)
@@ -212,5 +213,5 @@
 
 
-c   42. pression intercouches :
+c   42. pression intercouches et fonction d'Exner:
 c
 c   -----------------------------------------------------------------
@@ -223,15 +224,27 @@
        unskap   = 1./ kappa
 c
-      DO l = 1, llmp1
+      DO l = 1, llm
+        zpk(   1,l ) = ppk(1,1,l)
         zplev( 1,l ) = pp(1,1,l)
         ig0 = 2
           DO j = 2, jjm
              DO i =1, iim
+              zpk(   ig0,l ) = ppk(i,j,l)
               zplev( ig0,l ) = pp(i,j,l)
               ig0 = ig0 +1
              ENDDO
           ENDDO
+        zpk(   ngridmx,l ) = ppk(1,jjp1,l)
         zplev( ngridmx,l ) = pp(1,jjp1,l)
       ENDDO
+        zplev( 1,llmp1 ) = pp(1,1,llmp1)
+        ig0 = 2
+          DO j = 2, jjm
+             DO i =1, iim
+              zplev( ig0,llmp1 ) = pp(i,j,llmp1)
+              ig0 = ig0 +1
+             ENDDO
+          ENDDO
+        zplev( ngridmx,llmp1 ) = pp(1,jjp1,llmp1)
 c
 c
@@ -472,5 +485,5 @@
      &                   jD_cur,jH_cur_split,zdt_split,
      &                   zplev,zplay,
-     &                   zphi,zphis,
+     &                   zpk,zphi,zphis,
      &                   presnivs,
      &                   zufi,zvfi,zrfi,ztfi,zqfi,
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/calfis_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/calfis_loc.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/calfis_loc.F	(revision 2641)
@@ -50,4 +50,6 @@
       USE callphysiq_mod, ONLY: call_physiq
 #endif 
+      USE comvert_mod, ONLY: preff, presnivs
+      USE comconst_mod, ONLY: cpp, daysec, dtphys, dtvr, kappa, pi
 
 #ifdef CPP_PARA
@@ -107,15 +109,12 @@
 c    ------------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "temps.h"
+      include "dimensions.h"
+      include "paramet.h"
 
       INTEGER ngridmx
       PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
 
-#include "comconst.h"
-#include "comvert.h"
-#include "comgeom2.h"
-#include "iniprint.h"
+      include "comgeom2.h"
+      include "iniprint.h"
 #ifdef CPP_MPI
       include 'mpif.h'
@@ -163,4 +162,5 @@
       REAL,ALLOCATABLE,SAVE :: zufi(:,:), zvfi(:,:), zrfi(:,:)
       REAL,ALLOCATABLE,SAVE :: ztfi(:,:),zqfi(:,:,:)
+      REAL,ALLOCATABLE,SAVE ::  zpk(:,:)
 c
       REAL,ALLOCATABLE,SAVE :: pcvgu(:,:), pcvgv(:,:)
@@ -175,4 +175,5 @@
       REAL,ALLOCATABLE,SAVE :: zplev_omp(:,:)
       REAL,ALLOCATABLE,SAVE :: zplay_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zpk_omp(:,:)
       REAL,ALLOCATABLE,SAVE :: zphi_omp(:,:)
       REAL,ALLOCATABLE,SAVE :: zphis_omp(:)
@@ -212,5 +213,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-c$OMP THREADPRIVATE(zplev_omp,zplay_omp,zphi_omp,zphis_omp,
+c$OMP THREADPRIVATE(zplev_omp,zplay_omp,zpk_omp,zphi_omp,zphis_omp,
 c$OMP+                 presnivs_omp,zufi_omp,zvfi_omp,ztfi_omp,
 c$OMP+                 zrfi_omp,zqfi_omp,zdufi_omp,zdvfi_omp,
@@ -276,6 +277,7 @@
       ALLOCATE(zdufi2(klon+iim,llm),zdvfi2(klon+iim,llm))
       ALLOCATE(flxwfi(klon,llm))
+      ALLOCATE(zpk(klon,llm))
 c$OMP END MASTER
-c$OMP BARRIER	  
+c$OMP BARRIER          
       ELSE
           debut = .FALSE.
@@ -329,4 +331,15 @@
       ENDDO
 c$OMP END DO NOWAIT
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l=1,llm
+        do ig0=1,klon
+          i=index_i(ig0)
+          j=index_j(ig0)
+          zpk(ig0,l)=ppk(i,j,l)
+        enddo
+      ENDDO
+c$OMP END DO NOWAIT
+
 c
 c
@@ -365,5 +378,5 @@
            enddo
          ENDDO
-c$OMP END DO NOWAIT	 
+c$OMP END DO NOWAIT         
       ENDDO
 
@@ -382,5 +395,5 @@
            enddo
          ENDDO
-c$OMP END DO NOWAIT	 
+c$OMP END DO NOWAIT         
 
 c      CALL gr_dyn_fi_p(llm,iip1,jjp1,klon,pphi,zphi)
@@ -403,7 +416,7 @@
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
-	 DO ig=1,klon
-	   zphi(ig,l)=zphi(ig,l)-zphis(ig)
-	 ENDDO
+         DO ig=1,klon
+           zphi(ig,l)=zphi(ig,l)-zphis(ig)
+         ENDDO
       ENDDO
 c$OMP END DO NOWAIT
@@ -532,10 +545,10 @@
            DO i=2,iim
              z1(i)   =(rlonu(i)-rlonu(i-1))*pvcov(i,jjm,l)/cv(i,jjm)
-	   ENDDO
+           ENDDO
   
            DO i=1,iim
               zcos(i)    = COS(rlonv(i))*z1(i)
               zsin(i)    = SIN(rlonv(i))*z1(i)
-	   ENDDO
+           ENDDO
   
            zufi(klon,l)  = SSUM(iim,zcos,1)/pi
@@ -572,4 +585,5 @@
         allocate(zplev_omp(klon,llm+1))
         allocate(zplay_omp(klon,llm))
+        allocate(zpk_omp(klon,llm))
         allocate(zphi_omp(klon,llm))
         allocate(zphis_omp(klon))
@@ -590,8 +604,8 @@
         allocate(zdpsrf_omp(klon))
         allocate(flxwfi_omp(klon,llm))
-	first_omp=.false.
+        first_omp=.false.
       endif
        
-	   
+           
       klon=klon_omp
       offset=klon_omp_begin-1
@@ -600,10 +614,16 @@
         do i=1,klon
           zplev_omp(i,l)=zplev(offset+i,l)
-	enddo 
-      enddo
-	  
+        enddo 
+      enddo
+          
        do l=1,llm
         do i=1,klon  
-	  zplay_omp(i,l)=zplay(offset+i,l)
+          zplay_omp(i,l)=zplay(offset+i,l)
+        enddo 
+      enddo
+        
+       do l=1,llm
+        do i=1,klon  
+	  zpk_omp(i,l)=zpk(offset+i,l)
 	enddo 
       enddo
@@ -611,77 +631,77 @@
       do l=1,llm
         do i=1,klon
-	  zphi_omp(i,l)=zphi(offset+i,l)
-	enddo 
-      enddo
-	
+          zphi_omp(i,l)=zphi(offset+i,l)
+        enddo 
+      enddo
+        
       do i=1,klon
-	zphis_omp(i)=zphis(offset+i)
+        zphis_omp(i)=zphis(offset+i)
       enddo 
      
-	
+        
       do l=1,llm
         presnivs_omp(l)=presnivs(l)
       enddo 
-	
-      do l=1,llm
-        do i=1,klon
-	  zufi_omp(i,l)=zufi(offset+i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zvfi_omp(i,l)=zvfi(offset+i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zrfi_omp(i,l)=zrfi(offset+i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  ztfi_omp(i,l)=ztfi(offset+i,l)
-	enddo 
-      enddo
-	
+        
+      do l=1,llm
+        do i=1,klon
+          zufi_omp(i,l)=zufi(offset+i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zvfi_omp(i,l)=zvfi(offset+i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zrfi_omp(i,l)=zrfi(offset+i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          ztfi_omp(i,l)=ztfi(offset+i,l)
+        enddo 
+      enddo
+        
       do iq=1,nqtot
         do l=1,llm
           do i=1,klon
             zqfi_omp(i,l,iq)=zqfi(offset+i,l,iq)
-	  enddo
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zdufi_omp(i,l)=zdufi(offset+i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zdvfi_omp(i,l)=zdvfi(offset+i,l)
-	enddo 
-      enddo
-	
+          enddo
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zdufi_omp(i,l)=zdufi(offset+i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zdvfi_omp(i,l)=zdvfi(offset+i,l)
+        enddo 
+      enddo
+        
       do l=1,llm
         do i=1,klon
           zdtfi_omp(i,l)=zdtfi(offset+i,l)
-	enddo 
-      enddo
-	
+        enddo 
+      enddo
+        
       do iq=1,nqtot
         do l=1,llm
           do i=1,klon
-	    zdqfi_omp(i,l,iq)=zdqfi(offset+i,l,iq)
-	  enddo 
+            zdqfi_omp(i,l,iq)=zdqfi(offset+i,l,iq)
+          enddo 
         enddo
       enddo
-      	
+              
       do i=1,klon
-	zdpsrf_omp(i)=zdpsrf(offset+i)
+        zdpsrf_omp(i)=zdpsrf(offset+i)
       enddo 
 
@@ -689,5 +709,5 @@
         do i=1,klon
           flxwfi_omp(i,l)=flxwfi(offset+i,l)
-	enddo 
+        enddo 
       enddo
       
@@ -715,5 +735,5 @@
      &                   jD_cur,jH_cur_split,zdt_split,
      &                   zplev_omp,zplay_omp,
-     &                   zphi_omp,zphis_omp,
+     &                   zpk_omp,zphi_omp,zphis_omp,
      &                   presnivs_omp,
      &                   zufi_omp,zvfi_omp,zrfi_omp,ztfi_omp,zqfi_omp,
@@ -749,83 +769,83 @@
         do i=1,klon
           zplev(offset+i,l)=zplev_omp(i,l)
-	enddo 
-      enddo
-	  
+        enddo 
+      enddo
+          
        do l=1,llm
         do i=1,klon  
-	  zplay(offset+i,l)=zplay_omp(i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zphi(offset+i,l)=zphi_omp(i,l)
-	enddo 
-      enddo
-	
+          zplay(offset+i,l)=zplay_omp(i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zphi(offset+i,l)=zphi_omp(i,l)
+        enddo 
+      enddo
+        
 
       do i=1,klon
-	zphis(offset+i)=zphis_omp(i)
+        zphis(offset+i)=zphis_omp(i)
       enddo 
      
-	
+        
       do l=1,llm
         presnivs(l)=presnivs_omp(l)
       enddo 
-	
-      do l=1,llm
-        do i=1,klon
-	  zufi(offset+i,l)=zufi_omp(i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zvfi(offset+i,l)=zvfi_omp(i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  ztfi(offset+i,l)=ztfi_omp(i,l)
-	enddo 
-      enddo
-	
+        
+      do l=1,llm
+        do i=1,klon
+          zufi(offset+i,l)=zufi_omp(i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zvfi(offset+i,l)=zvfi_omp(i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          ztfi(offset+i,l)=ztfi_omp(i,l)
+        enddo 
+      enddo
+        
       do iq=1,nqtot
         do l=1,llm
           do i=1,klon
             zqfi(offset+i,l,iq)=zqfi_omp(i,l,iq)
-	  enddo
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zdufi(offset+i,l)=zdufi_omp(i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zdvfi(offset+i,l)=zdvfi_omp(i,l)
-	enddo 
-      enddo
-	
+          enddo
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zdufi(offset+i,l)=zdufi_omp(i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zdvfi(offset+i,l)=zdvfi_omp(i,l)
+        enddo 
+      enddo
+        
       do l=1,llm
         do i=1,klon
           zdtfi(offset+i,l)=zdtfi_omp(i,l)
-	enddo 
-      enddo
-	
+        enddo 
+      enddo
+        
       do iq=1,nqtot
         do l=1,llm
           do i=1,klon
-	    zdqfi(offset+i,l,iq)=zdqfi_omp(i,l,iq)
-	  enddo 
+            zdqfi(offset+i,l,iq)=zdqfi_omp(i,l,iq)
+          enddo 
         enddo
       enddo
-      	
+              
       do i=1,klon
-	zdpsrf(offset+i)=zdpsrf_omp(i)
+        zdpsrf(offset+i)=zdpsrf_omp(i)
       enddo 
       
@@ -929,5 +949,5 @@
        
        if (.not. is_south_pole_dyn) then
-	 pdpsfi(:,jj_end:jj_end+1)=0
+         pdpsfi(:,jj_end:jj_end+1)=0
        endif
 c$OMP END MASTER
@@ -1045,5 +1065,5 @@
         pdqfi(:,jj_begin:jj_end,l,:)=0.
       ENDDO
-c$OMP END DO NOWAIT	 
+c$OMP END DO NOWAIT         
 
 C
@@ -1056,5 +1076,5 @@
 !CDIR ON_ADB(index_j) 
 !cdir NODEP           
-	     DO ig0=kstart,kend
+             DO ig0=kstart,kend
               i=index_i(ig0)
               j=index_j(ig0)
@@ -1062,19 +1082,19 @@
               if (i==1) pdqfi(iip1,j,l,iiq) = zdqfi(ig0,l,iq)
             ENDDO
-	    
-	    IF (is_north_pole_dyn) then
-	      DO i=1,iip1
+            
+            IF (is_north_pole_dyn) then
+              DO i=1,iip1
                 pdqfi(i,1,l,iiq)    = zdqfi(1,l,iq)
-	      ENDDO
-	    ENDIF
-	    
-	    IF (is_south_pole_dyn) then
-	      DO i=1,iip1
+              ENDDO
+            ENDIF
+            
+            IF (is_south_pole_dyn) then
+              DO i=1,iip1
                 pdqfi(i,jjp1,l,iiq) = zdqfi(klon,l,iq)
-	      ENDDO
-	    ENDIF
-	    
+              ENDDO
+            ENDIF
+            
          ENDDO
-c$OMP END DO NOWAIT	 
+c$OMP END DO NOWAIT         
       ENDDO
       
@@ -1136,6 +1156,6 @@
            pdvfi(i,j,l)=0.5*(zdvfi2(ig0,l)+zdvfi2(ig0+iim,l))*cv(i,j)
            if (i==1) pdvfi(iip1,j,l) = 0.5*(zdvfi2(ig0,l)+
-     $	                                    zdvfi2(ig0+iim,l))
-     $				          *cv(i,j)
+     $                                            zdvfi2(ig0+iim,l))
+     $                                          *cv(i,j)
         enddo
          
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/calfis_p.F
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/calfis_p.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/calfis_p.F	(revision 2641)
@@ -47,4 +47,6 @@
       USE callphysiq_mod, ONLY: call_physiq
 #endif 
+      USE comvert_mod, ONLY: preff, presnivs
+      USE comconst_mod, ONLY: cpp, daysec, dtphys, dtvr, kappa, pi
 
       IMPLICIT NONE
@@ -105,11 +107,8 @@
 #include "dimensions.h"
 #include "paramet.h"
-#include "temps.h"
 
       INTEGER ngridmx
       PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
 
-#include "comconst.h"
-#include "comvert.h"
 #include "comgeom2.h"
 #include "iniprint.h"
@@ -159,7 +158,9 @@
       REAL,ALLOCATABLE,SAVE :: zphi(:,:),zphis(:)
 c
-      REAL zrot(iip1,jjb_v:jje_v,llm) ! AdlC May 2014
+!      REAL zrot(iip1,jjb_v:jje_v,llm) ! AdlC May 2014
+      REAL :: zrot(iip1,jjm,llm)
       REAL,ALLOCATABLE,SAVE :: zufi(:,:), zvfi(:,:), zrfi(:,:)
       REAL,ALLOCATABLE,SAVE :: ztfi(:,:),zqfi(:,:,:)
+      REAL,ALLOCATABLE,SAVE ::  zpk(:,:)
 c
       REAL,ALLOCATABLE,SAVE :: pcvgu(:,:), pcvgv(:,:)
@@ -174,4 +175,5 @@
       REAL,ALLOCATABLE,SAVE :: zplev_omp(:,:)
       REAL,ALLOCATABLE,SAVE :: zplay_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zpk_omp(:,:)
       REAL,ALLOCATABLE,SAVE :: zphi_omp(:,:)
       REAL,ALLOCATABLE,SAVE :: zphis_omp(:)
@@ -211,5 +213,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-c$OMP THREADPRIVATE(zplev_omp,zplay_omp,zphi_omp,zphis_omp,
+c$OMP THREADPRIVATE(zplev_omp,zplay_omp,zpk_omp,zphi_omp,zphis_omp,
 c$OMP+                 presnivs_omp,zufi_omp,zvfi_omp,ztfi_omp,
 c$OMP+                 zrfi_omp,zqfi_omp,zdufi_omp,zdvfi_omp,
@@ -275,6 +277,7 @@
       ALLOCATE(zdufi2(klon+iim,llm),zdvfi2(klon+iim,llm))
       ALLOCATE(flxwfi(klon,llm))
+      ALLOCATE(zpk(klon,llm))
 c$OMP END MASTER
-c$OMP BARRIER	  
+c$OMP BARRIER          
       ELSE
           debut = .FALSE.
@@ -328,4 +331,15 @@
       ENDDO
 c$OMP END DO NOWAIT
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+      DO l=1,llm
+        do ig0=1,klon
+          i=index_i(ig0)
+          j=index_j(ig0)
+          zpk(ig0,l)=ppk(i,j,l)
+        enddo
+      ENDDO
+c$OMP END DO NOWAIT
+
 c
 c
@@ -364,5 +378,5 @@
            enddo
          ENDDO
-c$OMP END DO NOWAIT	 
+c$OMP END DO NOWAIT         
       ENDDO
 
@@ -379,7 +393,7 @@
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
-	 DO ig=1,klon
-	   zphi(ig,l)=zphi(ig,l)-zphis(ig)
-	 ENDDO
+         DO ig=1,klon
+           zphi(ig,l)=zphi(ig,l)-zphis(ig)
+         ENDDO
       ENDDO
 c$OMP END DO NOWAIT
@@ -509,10 +523,10 @@
            DO i=2,iim
              z1(i)   =(rlonu(i)-rlonu(i-1))*pvcov(i,jjm,l)/cv(i,jjm)
-	   ENDDO
+           ENDDO
   
            DO i=1,iim
               zcos(i)    = COS(rlonv(i))*z1(i)
               zsin(i)    = SIN(rlonv(i))*z1(i)
-	   ENDDO
+           ENDDO
   
            zufi(klon,l)  = SSUM(iim,zcos,1)/pi
@@ -537,4 +551,5 @@
         allocate(zplev_omp(klon,llm+1))
         allocate(zplay_omp(klon,llm))
+        allocate(zpk_omp(klon,llm))
         allocate(zphi_omp(klon,llm))
         allocate(zphis_omp(klon))
@@ -555,8 +570,8 @@
         allocate(zdpsrf_omp(klon))
         allocate(flxwfi_omp(klon,llm))
-	first_omp=.false.
+        first_omp=.false.
       endif
        
-	   
+           
       klon=klon_omp
       offset=klon_omp_begin-1
@@ -565,10 +580,16 @@
         do i=1,klon
           zplev_omp(i,l)=zplev(offset+i,l)
-	enddo 
-      enddo
-	  
+        enddo 
+      enddo
+          
        do l=1,llm
         do i=1,klon  
-	  zplay_omp(i,l)=zplay(offset+i,l)
+          zplay_omp(i,l)=zplay(offset+i,l)
+        enddo 
+      enddo
+        
+       do l=1,llm
+        do i=1,klon  
+	  zpk_omp(i,l)=zpk(offset+i,l)
 	enddo 
       enddo
@@ -576,78 +597,78 @@
       do l=1,llm
         do i=1,klon
-	  zphi_omp(i,l)=zphi(offset+i,l)
-	enddo 
-      enddo
-	
+          zphi_omp(i,l)=zphi(offset+i,l)
+        enddo 
+      enddo
+        
       do i=1,klon
-	zphis_omp(i)=zphis(offset+i)
+        zphis_omp(i)=zphis(offset+i)
       enddo 
      
-	
+        
       do l=1,llm
         presnivs_omp(l)=presnivs(l)
       enddo 
-	
-      do l=1,llm
-        do i=1,klon
-	  zufi_omp(i,l)=zufi(offset+i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zvfi_omp(i,l)=zvfi(offset+i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zrfi_omp(i,l)=zrfi(offset+i,l)
-	enddo 
-      enddo
-	
-	
-      do l=1,llm
-        do i=1,klon
-	  ztfi_omp(i,l)=ztfi(offset+i,l)
-	enddo 
-      enddo
-	
+        
+      do l=1,llm
+        do i=1,klon
+          zufi_omp(i,l)=zufi(offset+i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zvfi_omp(i,l)=zvfi(offset+i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zrfi_omp(i,l)=zrfi(offset+i,l)
+        enddo 
+      enddo
+        
+        
+      do l=1,llm
+        do i=1,klon
+          ztfi_omp(i,l)=ztfi(offset+i,l)
+        enddo 
+      enddo
+        
       do iq=1,nqtot
         do l=1,llm
           do i=1,klon
             zqfi_omp(i,l,iq)=zqfi(offset+i,l,iq)
-	  enddo
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zdufi_omp(i,l)=zdufi(offset+i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zdvfi_omp(i,l)=zdvfi(offset+i,l)
-	enddo 
-      enddo
-	
+          enddo
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zdufi_omp(i,l)=zdufi(offset+i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zdvfi_omp(i,l)=zdvfi(offset+i,l)
+        enddo 
+      enddo
+        
       do l=1,llm
         do i=1,klon
           zdtfi_omp(i,l)=zdtfi(offset+i,l)
-	enddo 
-      enddo
-	
+        enddo 
+      enddo
+        
       do iq=1,nqtot
         do l=1,llm
           do i=1,klon
-	    zdqfi_omp(i,l,iq)=zdqfi(offset+i,l,iq)
-	  enddo 
+            zdqfi_omp(i,l,iq)=zdqfi(offset+i,l,iq)
+          enddo 
         enddo
       enddo
-      	
+              
       do i=1,klon
-	zdpsrf_omp(i)=zdpsrf(offset+i)
+        zdpsrf_omp(i)=zdpsrf(offset+i)
       enddo 
 
@@ -655,5 +676,5 @@
         do i=1,klon
           flxwfi_omp(i,l)=flxwfi(offset+i,l)
-	enddo 
+        enddo 
       enddo
       
@@ -680,5 +701,5 @@
      &                   jD_cur,jH_cur_split,zdt_split,
      &                   zplev_omp,zplay_omp,
-     &                   zphi_omp,zphis_omp,
+     &                   zpk_omp,zphi_omp,zphis_omp,
      &                   presnivs_omp,
      &                   zufi_omp,zvfi_omp,zrfi_omp,ztfi_omp,zqfi_omp,
@@ -712,83 +733,83 @@
         do i=1,klon
           zplev(offset+i,l)=zplev_omp(i,l)
-	enddo 
-      enddo
-	  
+        enddo 
+      enddo
+          
        do l=1,llm
         do i=1,klon  
-	  zplay(offset+i,l)=zplay_omp(i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zphi(offset+i,l)=zphi_omp(i,l)
-	enddo 
-      enddo
-	
+          zplay(offset+i,l)=zplay_omp(i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zphi(offset+i,l)=zphi_omp(i,l)
+        enddo 
+      enddo
+        
 
       do i=1,klon
-	zphis(offset+i)=zphis_omp(i)
+        zphis(offset+i)=zphis_omp(i)
       enddo 
      
-	
+        
       do l=1,llm
         presnivs(l)=presnivs_omp(l)
       enddo 
-	
-      do l=1,llm
-        do i=1,klon
-	  zufi(offset+i,l)=zufi_omp(i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zvfi(offset+i,l)=zvfi_omp(i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  ztfi(offset+i,l)=ztfi_omp(i,l)
-	enddo 
-      enddo
-	
+        
+      do l=1,llm
+        do i=1,klon
+          zufi(offset+i,l)=zufi_omp(i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zvfi(offset+i,l)=zvfi_omp(i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          ztfi(offset+i,l)=ztfi_omp(i,l)
+        enddo 
+      enddo
+        
       do iq=1,nqtot
         do l=1,llm
           do i=1,klon
             zqfi(offset+i,l,iq)=zqfi_omp(i,l,iq)
-	  enddo
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zdufi(offset+i,l)=zdufi_omp(i,l)
-	enddo 
-      enddo
-	
-      do l=1,llm
-        do i=1,klon
-	  zdvfi(offset+i,l)=zdvfi_omp(i,l)
-	enddo 
-      enddo
-	
+          enddo
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zdufi(offset+i,l)=zdufi_omp(i,l)
+        enddo 
+      enddo
+        
+      do l=1,llm
+        do i=1,klon
+          zdvfi(offset+i,l)=zdvfi_omp(i,l)
+        enddo 
+      enddo
+        
       do l=1,llm
         do i=1,klon
           zdtfi(offset+i,l)=zdtfi_omp(i,l)
-	enddo 
-      enddo
-	
+        enddo 
+      enddo
+        
       do iq=1,nqtot
         do l=1,llm
           do i=1,klon
-	    zdqfi(offset+i,l,iq)=zdqfi_omp(i,l,iq)
-	  enddo 
+            zdqfi(offset+i,l,iq)=zdqfi_omp(i,l,iq)
+          enddo 
         enddo
       enddo
-      	
+              
       do i=1,klon
-	zdpsrf(offset+i)=zdpsrf_omp(i)
+        zdpsrf(offset+i)=zdpsrf_omp(i)
       enddo 
       
@@ -891,5 +912,5 @@
        pdpsfi(:,jj_begin)=0    
        if (.not. is_south_pole_dyn) then
-	 pdpsfi(:,jj_end)=0
+         pdpsfi(:,jj_end)=0
        endif
 c$OMP END MASTER
@@ -975,5 +996,5 @@
         pdqfi(:,:,l,:)=0.
       ENDDO
-c$OMP END DO NOWAIT	 
+c$OMP END DO NOWAIT         
 
 C
@@ -986,5 +1007,5 @@
 !CDIR ON_ADB(index_j) 
 !cdir NODEP           
-	     DO ig0=kstart,kend
+             DO ig0=kstart,kend
               i=index_i(ig0)
               j=index_j(ig0)
@@ -992,19 +1013,19 @@
               if (i==1) pdqfi(iip1,j,l,iiq) = zdqfi(ig0,l,iq)
             ENDDO
-	    
-	    IF (is_north_pole_dyn) then
-	      DO i=1,iip1
+            
+            IF (is_north_pole_dyn) then
+              DO i=1,iip1
                 pdqfi(i,1,l,iiq)    = zdqfi(1,l,iq)
-	      ENDDO
-	    ENDIF
-	    
-	    IF (is_south_pole_dyn) then
-	      DO i=1,iip1
+              ENDDO
+            ENDIF
+            
+            IF (is_south_pole_dyn) then
+              DO i=1,iip1
                 pdqfi(i,jjp1,l,iiq) = zdqfi(klon,l,iq)
-	      ENDDO
-	    ENDIF
-	    
+              ENDDO
+            ENDIF
+            
          ENDDO
-c$OMP END DO NOWAIT	 
+c$OMP END DO NOWAIT         
       ENDDO
       
@@ -1066,6 +1087,6 @@
            pdvfi(i,j,l)=0.5*(zdvfi2(ig0,l)+zdvfi2(ig0+iim,l))*cv(i,j)
            if (i==1) pdvfi(iip1,j,l) = 0.5*(zdvfi2(ig0,l)+
-     $	                                    zdvfi2(ig0+iim,l))
-     $				          *cv(i,j)
+     $                                            zdvfi2(ig0+iim,l))
+     $                                          *cv(i,j)
         enddo
          
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90	(revision 2641)
@@ -12,5 +12,5 @@
                        jD_cur,jH_cur_split,zdt_split,                     &
                        zplev_omp,zplay_omp,                               &
-                       zphi_omp,zphis_omp,                                &
+                       zpk_omp,zphi_omp,zphis_omp,                        &
                        presnivs_omp,                                      &
                        zufi_omp,zvfi_omp,zrfi_omp,ztfi_omp,zqfi_omp,      &
@@ -35,4 +35,5 @@
   REAL,INTENT(IN) :: zplev_omp(klon,llm+1) ! interlayer pressure (Pa)
   REAL,INTENT(IN) :: zplay_omp(klon,llm) ! mid-layer pressure (Pa)
+  REAL,INTENT(IN) :: zpk_omp(klon,llm) ! Exner function
   REAL,INTENT(IN) :: zphi_omp(klon,llm) ! geopotential at midlayer
   REAL,INTENT(IN) :: zphis_omp(klon) ! surface geopotential
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/ce0l.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 2641)
@@ -34,4 +34,9 @@
   USE mod_interface_dyn_phys, ONLY: init_interface_dyn_phys
 #endif
+  USE comconst_mod, ONLY: cpp, daysec, dtphys, dtvr, g, kappa, omeg, r, rad, &
+                          pi, jmp1
+  USE logic_mod, ONLY: iflag_phys, ok_etat0, ok_limit
+  USE comvert_mod, ONLY: pa, preff, pressure_exner
+  USE temps_mod, ONLY: calend, day_ini, dt
 
   IMPLICIT NONE
@@ -42,9 +47,5 @@
   include "paramet.h"
   include "comgeom2.h"
-  include "comconst.h"
-  include "comvert.h"
   include "iniprint.h"
-  include "temps.h"
-  include "logic.h"
   REAL               :: masque(iip1,jjp1)             !--- CONTINENTAL MASK
   REAL               :: phis  (iip1,jjp1)             !--- GROUND GEOPOTENTIAL
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 2641)
@@ -36,4 +36,8 @@
   USE ioipsl,         ONLY: flininfo, flinopen, flinget, flinclo, histclo
   USE assert_eq_m,    ONLY: assert_eq
+  USE comconst_mod, ONLY: pi, cpp, kappa
+  USE comvert_mod, ONLY: ap, bp, preff, pressure_exner
+  USE temps_mod, ONLY: annee_ref, day_ref, itau_dyn, itau_phy
+  
   IMPLICIT NONE
 
@@ -45,9 +49,5 @@
   include "paramet.h"
   include "comgeom2.h"
-  include "comvert.h"
-  include "comconst.h"
-  include "temps.h"
   include "comdissnew.h"
-  include "serre.h"
   REAL, SAVE :: deg2rad
   INTEGER,            SAVE      :: iml_dyn, jml_dyn, llm_dyn, ttm_dyn, fid_dyn
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 2641)
@@ -44,4 +44,5 @@
     zmax0,fevap, rnebcon,falb_dir, wake_fip,    agesno,  detr_therm, pbl_tke,  &
     phys_state_var_init
+  USE comconst_mod, ONLY: pi, dtvr
 
   PRIVATE
@@ -52,7 +53,5 @@
   include "paramet.h"
   include "comgeom2.h"
-  include "comconst.h"
   include "dimsoil.h"
-  include "temps.h"
   include "clesphys.h"
   REAL, SAVE :: deg2rad
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 2641)
@@ -12,6 +12,7 @@
                      prad,pg,pr,pcpp,iflag_phys)
   USE dimphy, ONLY: init_dimphy
+  USE comvert_mod, ONLY: preff, ap, bp, presnivs, scaleheight, pseudoalt
   USE inigeomphy_mod, ONLY: inigeomphy
-  USE mod_grid_phy_lmdz, ONLY: klon_glo ! number of atmospheric columns (on full grid)
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon,nbp_lat,nbp_lev,klon_glo ! number of atmospheric columns (on full grid)
   USE mod_phys_lmdz_para, ONLY: klon_omp ! number of columns (on local omp grid)
   USE vertical_layers_mod, ONLY : init_vertical_layers
@@ -28,7 +29,8 @@
   USE CHEM_REP, ONLY : Init_chem_rep_phys
 #endif
-  USE control_mod, ONLY: dayref,anneeref,day_step,nday,offline, iphysiq
+  USE control_mod, ONLY: dayref,anneeref,day_step,nday,offline, iphysiq, config_inca
   USE inifis_mod, ONLY: inifis
   USE time_phylmdz_mod, ONLY: init_time
+  USE temps_mod, ONLY: annee_ref, day_ini, day_ref, start_time, calend
   USE infotrac_phy, ONLY: init_infotrac_phy
   USE phystokenc_mod, ONLY: init_phystokenc
@@ -50,8 +52,5 @@
 
   include "dimensions.h"
-  include "comvert.h"
-  include "comconst.h"
   include "iniprint.h"
-  include "temps.h"
   include "tracstoke.h"
 
@@ -99,5 +98,8 @@
   ! --> now initialize things specific to the phylmd physics package
   
-!$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/)
+!!$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/)
+!$OMP PARALLEL DEFAULT(SHARED) &
+!	Copy all threadprivate variables in temps_mod
+!$OMP COPYIN(annee_ref, day_ini, day_ref, start_time)
 
   ! copy over preff , ap(), bp(), etc 
@@ -139,5 +141,6 @@
      call init_const_lmdz( &
           anneeref,dayref, iphysiq,day_step,nday,  &
-          nbsrf, is_oce,is_sic, is_ter,is_lic, calend)
+          nbsrf, is_oce,is_sic, is_ter,is_lic, calend, &
+          config_inca)
      call init_inca_para( &
           nbp_lon,nbp_lat,nbp_lev,klon_glo,mpi_size, &
@@ -145,6 +148,7 @@
 #endif
   END IF
-!$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/)
 
+!!$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/)
+!$OMP PARALLEL DEFAULT(SHARED)
   ! Additional initializations for aquaplanets 
   IF (iflag_phys>=100) THEN
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/init_ssrf_m.F90	(revision 2641)
@@ -9,4 +9,5 @@
   USE grid_atob_m,        ONLY: grille_m
   USE ioipsl,             ONLY: flininfo, flinopen, flinget, flinclo
+  USE comconst_mod, ONLY: im, pi
 
   CHARACTER(LEN=256), PARAMETER :: icefname="landiceref.nc", icevar="landice"
@@ -17,5 +18,4 @@
   include "paramet.h"
   include "comgeom2.h"
-  include "comconst.h"
 
 CONTAINS
